    clear
clf();
//given matrix M and K,and distance g
m1 = 1.0; m2 = 1.0; k1 =1.0; k2 =1.0;
g = 1.0;

//Find matrix P such that P'MP =I and P'KP = diag(w1^2;w2^2)

M=[m2,0;0,m1];
K=[k2,-k2;-k2,k1+k2];
L=[sqrt(m2),0;0,sqrt(m1)];
Z=inv(L)*K*inv(L');
omega=spec(Z);
[R,diagevals] =spec(Z);

P=inv(L)*R;
iP=inv(P);
C=P'*K*P-diagevals*P'*M*P; // check that P satisfies these conditions <10^-15 is ok

w1=sqrt(diagevals(1,1)); tau1=2*%pi/w1;
w2=sqrt(diagevals(2,2)); tau2=2*%pi/w2;

//Define functions Phi1(s), Phi2(s)
function Phi1=Phi1(s)
    Phi1=sin(w1*s)/(w1*(1-cos(w1*s)))
endfunction

function Phi2=Phi2(s)
    Phi2=sin(w2*s)/(w2*(1-cos(w2*s)))
endfunction

//Define the equation w.r.t s, in order to find s where s=T-T1

function W1=W1(s)
    W1=P(1,1)*iP(1,2)*Phi1(s)+P(1,2)*iP(2,2)*Phi2(s)
endfunction

function W2=W2(s)
    W2=P(2,1)*iP(1,2)*Phi1(s)+P(2,2)*iP(2,2)*Phi2(s)
endfunction

function h=h(s)
    h=W1(s)-W2(s)
endfunction

// Find v (initial velocity of m1) wrt s
function v2=v2(s)
    v2=g/W1(s)
endfunction


s0=fsolve(5,h)
v2=v2(s0)

//--------------------------------------------------------------------

 T=s0;

function udot=sys2(t,u)
         udot=B*u
endfunction
B=[0,0,1,0;0,0,0,1;-k2/m2,k2/m2,0,0;k2/m1,-(k1+k2)/m1,0,0];

t0=0;u0=[g;g;0;v2];
t=t0:0.01:T;
usol=ode(u0,t0,t,sys2);

//draw the phase orbit
//plot2d([usol(1,:)' usol(2,:)'],[usol(3,:)' usol(4,:)'],style=[5,2]);
//e=gce();
//hl=captions(e.children,['mass 1';'mass 2'],'in_lower_left');

plot(t',g,'gr-')
plot2d(t',[usol(1,:)' usol(2,:)'],style=[2,5]);
e=gce();
hl=captions(e.children,['mass 1';'mass 2'],'in_lower_left');
